// License : Apache License Version 2.0  https://www.apache.org/licenses/LICENSE-2.0
package com.github.quantrresearch.sharepoint.online.panel.doclib;

import com.github.quantrresearch.sharepoint.online.Helper;
import com.github.quantrresearch.sharepoint.online.datastructure.Field;
import com.github.quantrresearch.sharepoint.online.datastructure.ListInfo;
import com.github.quantrresearch.sharepoint.online.datastructure.ServerInfo;
import hk.quantr.javalib.CommonLib;
import hk.quantr.sharepoint.SPOnline;
import java.util.ArrayList;
import java.util.HashMap;
import org.apache.commons.lang3.tuple.Pair;
import org.json.JSONArray;
import org.json.JSONObject;
import org.openide.util.Exceptions;

/**
 *
 * @author Peter <peter@quantr.hk>
 */
public class DocLibPanel extends javax.swing.JPanel {

	ServerInfo serverInfo;
	ListInfo listInfo;
	public FileTableModel fileTableModel = new FileTableModel();
	HashMap<String, Field> fields = new HashMap<>();
	HashMap<String, Field> fieldsByTitle = new HashMap<>();

	public DocLibPanel(ServerInfo serverInfo, ListInfo listInfo) {
		super();
		this.serverInfo = serverInfo;
		this.listInfo = listInfo;
		initComponents();
		fileTable.setModel(fileTableModel);
		fileTable.setDefaultRenderer(Object.class, new FileTableCellRenderer());
		fileTable.getTableHeader().setReorderingAllowed(false);

		initFields();
		initViewCombo();
		initData();
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSplitPane1 = new javax.swing.JSplitPane();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        fileTable = new javax.swing.JTable();
        jToolBar1 = new javax.swing.JToolBar();
        jLabel1 = new javax.swing.JLabel();
        viewDataComboBox = new javax.swing.JComboBox<>();
        uploadButton = new javax.swing.JButton();

        setLayout(new java.awt.BorderLayout());

        jSplitPane1.setDividerLocation(200);

        jPanel1.setLayout(new java.awt.BorderLayout());

        jScrollPane1.setViewportView(jTree1);

        jPanel1.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jSplitPane1.setLeftComponent(jPanel1);

        jPanel2.setLayout(new java.awt.BorderLayout());

        fileTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        fileTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        fileTable.setRowHeight(22);
        jScrollPane2.setViewportView(fileTable);

        jPanel2.add(jScrollPane2, java.awt.BorderLayout.CENTER);

        jSplitPane1.setRightComponent(jPanel2);

        add(jSplitPane1, java.awt.BorderLayout.CENTER);

        jToolBar1.setRollover(true);

        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, org.openide.util.NbBundle.getMessage(DocLibPanel.class, "DocLibPanel.jLabel1.text")); // NOI18N
        jToolBar1.add(jLabel1);

        viewDataComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        viewDataComboBox.setMaximumSize(new java.awt.Dimension(200, 27));
        viewDataComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                viewDataComboBoxActionPerformed(evt);
            }
        });
        jToolBar1.add(viewDataComboBox);

        org.openide.awt.Mnemonics.setLocalizedText(uploadButton, org.openide.util.NbBundle.getMessage(DocLibPanel.class, "DocLibPanel.uploadButton.text")); // NOI18N
        uploadButton.setFocusable(false);
        uploadButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        uploadButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar1.add(uploadButton);

        add(jToolBar1, java.awt.BorderLayout.PAGE_START);
    }// </editor-fold>//GEN-END:initComponents

    private void viewDataComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_viewDataComboBoxActionPerformed
		initData();
    }//GEN-LAST:event_viewDataComboBoxActionPerformed

	private void initViewCombo() {
		Pair<String, String> token = SPOnline.login(serverInfo.username, serverInfo.password, serverInfo.domain);
		if (token != null) {
			ArrayList<String> columnNames = new ArrayList<>();
			String jsonString = SPOnline.post(token, serverInfo.domain, "/_api/contextinfo", null, null);
			jsonString = SPOnline.get(token, serverInfo.domain, serverInfo.path + "/_api/web/lists(guid'" + listInfo.id + "')/Views?$select=ID,Title");
			if (jsonString != null) {
				JSONObject json = new JSONObject(jsonString);
				JSONArray array = json.getJSONObject("d").getJSONArray("results");
				viewDataComboBox.removeAllItems();
				for (int x = 0; x < array.length(); x++) {
					JSONObject j = array.getJSONObject(x);
					viewDataComboBox.addItem(j.getString("Title"));
				}
			}
		}
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTable fileTable;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JTree jTree1;
    private javax.swing.JButton uploadButton;
    private javax.swing.JComboBox<String> viewDataComboBox;
    // End of variables declaration//GEN-END:variables

	private void initData() {
		try {
			Pair<String, String> token = SPOnline.login(serverInfo.username, serverInfo.password, serverInfo.domain);
			if (token != null) {
				String viewTitle = (String) viewDataComboBox.getSelectedItem();
				if (viewTitle == null) {
					return;
				}
				fileTableModel.columns.clear();
				fileTableModel.data.clear();
				String jsonString = SPOnline.post(token, serverInfo.domain, "/_api/contextinfo", null, null);
				JSONObject json = new JSONObject(jsonString);
				String formDigestValue = json.getJSONObject("d").getJSONObject("GetContextWebInformation").getString("FormDigestValue");

				String viewQuery = null;
				jsonString = SPOnline.get(token, serverInfo.domain, serverInfo.path + "/_api/web/lists(guid'" + listInfo.id + "')/Views/GetByTitle('" + Helper.escapeSharePointUrl(viewTitle) + "')");
				if (jsonString != null) {
					json = new JSONObject(jsonString);
					viewQuery = json.getJSONObject("d").getString("ViewQuery");
				}

				jsonString = SPOnline.get(token, serverInfo.domain, serverInfo.path + "/_api/web/lists(guid'" + listInfo.id + "')/Views/GetByTitle('" + Helper.escapeSharePointUrl(viewTitle) + "')/ViewFields");
				if (jsonString != null) {
					json = new JSONObject(jsonString);
					JSONArray array = json.getJSONObject("d").getJSONObject("Items").getJSONArray("results");
					for (int x = 0; x < array.length(); x++) {
						Field field = fields.get(array.getString(x));
						if (field != null) {
							fileTableModel.columns.add(field);
						} else {
							System.out.println("field is null " + array.getString(x));
						}
					}
				}

				//get data
				JSONObject data = new JSONObject();
				JSONObject __metadata = new JSONObject();
				data.put("query", __metadata);
				JSONObject type = new JSONObject();
				__metadata.put("__metadata", type);
				HashMap<String, String> map = new HashMap<>();
				map.put("type", "SP.CamlQuery");
				__metadata.put("__metadata", map);
				__metadata.put("ViewXml", "<View>"
						+ "<Query>" + viewQuery + "</Query>"
						+ "</View>");

//				System.out.println(CommonLib.prettyFormatJson(data.toString()));
				jsonString = SPOnline.post(token, serverInfo.domain, "/_api/web/lists/GetByTitle('doclib2')/GetItems", data.toString(), formDigestValue);
				json = new JSONObject(jsonString);
//				System.out.println("length=" + json.getJSONObject("d").getJSONArray("results").length());
//				System.out.println(CommonLib.prettyFormatJson(jsonString));

				if (jsonString != null) {
					System.out.println(CommonLib.formatJson(jsonString));
					json = new JSONObject(jsonString);
					JSONArray array = json.getJSONObject("d").getJSONArray("results");
					for (int x = 0; x < array.length(); x++) {
						ArrayList<Object> row = new ArrayList<>();
						JSONObject j = array.getJSONObject(x);
						for (Field field : fileTableModel.columns) {
							try {
//								if (field.type.equals("Computed")) {
//									row.add(j.getString(field.title));
//								} else if (field.type.equals("Number")) {
//									row.add(j.getInt(field.internalName));
//								} else if (field.type.equals("Date and Time")) {
//									row.add(j.getString(field.title));
//								} else if (field.type.equals("Person and Group")) {
//									System.out.println("j Person=" + j);
//									row.add(j.getString(field.title));
//								} else {
//									row.add(field);
//								}
								row.add(j.getString(field.title));
							} catch (Exception ex) {
								//ex.printStackTrace();
								if (field.internalName != null) {
									row.add("ERROR " + field.type + ", " + field.internalName);
								} else {
									row.add("ERROR " + field.type + ", " + field);
								}
							}
						}
						//System.out.println("r=" + row.size());
						fileTableModel.data.add(row);
					}
					fileTableModel.fireTableStructureChanged();
				}
				CommonLib.autoResizeColumn(fileTable);
			}
		} catch (Exception ex) {
			Exceptions.printStackTrace(ex);
		}
	}

	private void initFields() {
		Pair<String, String> token = SPOnline.login(serverInfo.username, serverInfo.password, serverInfo.domain);
		if (token != null) {
			String jsonString = SPOnline.post(token, serverInfo.domain, serverInfo.path + "/_api/contextinfo", null, null);
			jsonString = SPOnline.get(token, serverInfo.domain, serverInfo.path + "/_api/web/lists(guid'" + listInfo.id + "')/Fields");
			if (jsonString != null) {
				fields.clear();
				fieldsByTitle.clear();
				JSONObject json = new JSONObject(jsonString);
				JSONArray array = json.getJSONObject("d").getJSONArray("results");
				for (int x = 0; x < array.length(); x++) {
					JSONObject j = array.getJSONObject(x);
					fields.put(j.getString("EntityPropertyName"), new Field(j.getString("Title"), j.getString("TypeDisplayName"), j.getString("InternalName"), j.getString("StaticName")));
					fieldsByTitle.put(j.getString("Title"), new Field(j.getString("Title"), j.getString("TypeDisplayName"), j.getString("InternalName"), j.getString("StaticName")));
				}
			}
		}
	}
}
